<?php
/* MOD Topic Ratings Mod
* @ file functions_topic_rating.php
* @ copyright 2009 phpbb3-mods.com
* @ based on an idea from TheUniqueTiger
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

/* function get_rating_img to be used by viewforum and viewtopic
@param $rating float ... the current rating for the topic
@param $total_rating_votes ... total number of rating votes for this topic
*/
function get_rating_img($rating = 0, $total_rating_votes = 0)
{
	global $user;
	if ($total_rating_votes == 0)
	{
		return $user->lang['NOT_RATED'];
	}	
	$rating_img = '';
	$round_int = floor($rating);
	$round_fraction = $rating - $round_int;
	if ($round_fraction >= 0.25 && $round_fraction < 0.75) //for fractions from 0.25 to 0.74 display half icon
	{
		$rating_img = ' ' . $user->img('icon_topic_rating_half');		
	}
	elseif ($round_fraction >= 0.75) //for fractions >= 0.75, round to ceil int and show full icon
	{
		$round_int++;
	}
	$rating_img = str_repeat(' ' . $user->img('icon_topic_rating'), $round_int) . $rating_img;
	
	if ($rating < 0.25)
	{
		$rating_img = $user->lang['RATED_ZERO'];
	}
	
	return $rating_img;
}

/* function build_error_msg ... builds the message for error handler trigger_error
@param $error_obj = array(
	'message' => (The identifier in the $user->lang for the appropriate prompt),
	'return_topic' => (The topic_id of the topic to be returned to ... also the current topic ... by default this param = 0));
*/
function build_error_msg($error_obj)
{
	global $phpbb_root_path, $phpEx, $user;

	$message = $error_obj['message'] != '' ? $user->lang[$error_obj['message']] . '<br /><br />' : $user->lang['UNSPECIFIED_ERROR'];
	if ($error_obj['return_topic']) //return to the topic
	{
		$message .= "<a href='{$phpbb_root_path}viewtopic.$phpEx?t=$error_obj[return_topic]&sid=".$user->data['session_id']."'>{$user->lang['RETURN_TO_TOPIC']}</a><br /><br />";
	}
	//also a default link to return to index page
	$message .= "<a href='{$phpbb_root_path}index.$phpEx?sid=".$user->data['session_id']."'>{$user->lang['RETURN_TO_INDEX']}</a>";
	return $message;
}
//function build_error_msg($error_obj, $_SID)
//{
//   global $phpbb_root_path, $phpEx, $user;

//   $message = $error_obj['message'] != '' ? $user->lang[$error_obj['message']] . '<br /><br />' : $user->lang['UNSPECIFIED_ERROR'];
//   if ($error_obj['return_topic']) //return to the topic
//   {
//      $message .= "<a href='{$phpbb_root_path}viewtopic.$phpEx?t=$error_obj[return_topic]&sid=$_SID'>{$user->lang['RETURN_TO_TOPIC']}</a><br /><br />";
//   }
   //also a default link to return to index page
//   $message .= "<a href='{$phpbb_root_path}index.$phpEx?sid=$_SID'>{$user->lang['RETURN_TO_INDEX']}</a>";
//   return $message;
//}
/* function make_ratingbox ... to create the rating box
@param $topic_id ... the topic_id of the topic
*/
//function make_ratingbox($topic_id)
//{
//	global $phpbb_root_path, $phpEx, $user;
//	$result = "<form name='frmRating' method='get' action='{$phpbb_root_path}topic_rating.$phpEx'>
//		<input type='hidden' name='t' value='$topic_id' /><label for='ratingbox' style='vertical-align:middle;'>{L_RATE_TOPIC_EXPLAIN}</label>  <select id='ratingbox' name='rating'>";
//	for ($i = 5; $i >= 0; $i--) //highest rating first!
//	{
//		$result .= "<option value='$i'>$i : " . $user->lang['RATING_PROMPTS'][$i] . "</option>";
//	}
//	$result .= "</select><input type='hidden' name='sid' value='".$user->data['session_id']."' /> <input class='button2' type='submit' value='{L_RATE_TOPIC}' /></form>";
//	return $result;
//}
function make_ratingbox($topic_id, $_SID)
{
   global $phpbb_root_path, $phpEx, $user;
   $result = "<form name='frmRating' method='get' action='{$phpbb_root_path}topic_rating.$phpEx'>
      <input type='hidden' name='t' value='$topic_id' /><label for='ratingbox' style='vertical-align:middle;'>قيـّم هذا الموضوع</label>  <select id='ratingbox' name='rating'>";
   for ($i = 5; $i >= 0; $i--) //highest rating first!
   {
      $result .= "<option value='$i'>$i : " . $user->lang['RATING_PROMPTS'][$i] . "</option>";
   }
   $result .= "<input type='hidden' name='sid' value='{$_SID}'>";
   $result .= "</select> <input class='button2' type='submit' value='تقييم الموضوع' /></form>";
   return $result;
}
?>