<?php
/* MOD Topic Ratings Mod
* @ file topic_rating.php
* @ copyright 2009 phpbb3-mods.com
* @ based on an idea from TheUniqueTiger
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
* Some code from phpBB
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_topic_rating.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('topic_rating');

$error = array(
	'message' => '',
	'return_topic' => '0'
);

$topic_id = request_var('t', 0);
$rating = request_var('rating', -1);
$forum_id = '';
$topic_rating = 0.0;
$topic_rating_total_votes = 0;
$sql = '';
$result = '';

//check for guest user
if ($user->data['user_id'] == ANONYMOUS)
{
	$error['message'] = 'ANONYMOUS_USER';		
	trigger_error(build_error_msg($error, $_SID));
}

//check for invalid rating
if (!($rating >= 0 && $rating <= 5))
{	
	$error['message'] = 'INVALID_RATING';		
	trigger_error(build_error_msg($error));
}

//check for invalid topic
if (!$topic_id) //user did not send a topic id
{
	$error['message'] = 'INVALID_TOPIC';		
	trigger_error(build_error_msg($error));
}
else
{
  	$sql = "SELECT topic_id, forum_id, topic_status, topic_rating, topic_rating_total_votes, topic_rating_status, topic_poster FROM " . TOPICS_TABLE . "
		WHERE topic_id = $topic_id";
	$result = $db->sql_query($sql);
	$temp_row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	if (!$temp_row)
	{
		$error['message'] = 'INVALID_TOPIC';		
		trigger_error(build_error_msg($error));
	}
	else
    {
		$forum_id = $temp_row['forum_id'];
		if (!$auth->acl_get('f_read', $forum_id))
		{			
			$error['message'] = 'NO_PERMISSION';
			$error['return_topic'] = $topic_id;
			trigger_error(build_error_msg($error));
		}
		elseif ($temp_row['topic_status'] == ITEM_LOCKED || $temp_row['topic_rating_status'] == ITEM_LOCKED) //topic is locked or ratings are locked, user cannot rate
		{
			$error['message'] = 'LOCKED_TOPIC';
			$error['return_topic'] = $topic_id;
			trigger_error(build_error_msg($error));
		}
		elseif ($temp_row['topic_poster'] == $user->data['user_id']) //user cannot rate self topics
		{
			$error['message'] = 'USER_SELF_RATING';
			$error['return_topic'] = $topic_id;
			trigger_error(build_error_msg($error));
		}
		//proceed, assign the current topic ratings
		$topic_rating = $temp_row['topic_rating'];
		$topic_rating_total_votes = $temp_row['topic_rating_total_votes'];
	}
}

$user_id = $user->data['user_id'];
//query the db to get the forum for this topic... any row returned means user has already rated this topic
$sql = "SELECT * 
	FROM " . TOPICS_RATED_TABLE . " r 
	WHERE r.user_id = $user_id AND r.topic_id = $topic_id AND r.topic_rated = 1";

$result = $db->sql_query($sql);
$temp_row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

if ($temp_row)
{	
	$error['message'] = 'ALREADY_RATED';
	$error['return_topic'] = $topic_id;
	trigger_error(build_error_msg($error));//<br /><br /><a href='{$phpbb_root_path}viewtopic.$phpEx?t=$topic_id'>Return to topic</a><br /><br /><a href='{$phpbb_root_path}index.$phpEx>Return to Forum Index</a>");
}

//all checked now set the rating for this topic
$new_rating = ($topic_rating_total_votes * $topic_rating + $rating) / ($topic_rating_total_votes + 1);
$topic_rating_total_votes++;

//insert the new rating into the db
$db->sql_transaction('begin');
$sql = "INSERT INTO " . TOPICS_RATED_TABLE . "
	VALUES ($user_id, $topic_id, 1, $rating)";	
$db->sql_query($sql);

$sql = "UPDATE " . TOPICS_TABLE . "
	SET topic_rating = $new_rating, topic_rating_total_votes = $topic_rating_total_votes 
	WHERE topic_id = $topic_id";
$db->sql_query($sql);
$db->sql_transaction('commit');

//take the user to the redirection page
$redirect_url = append_sid("{$phpbb_root_path}viewtopic.$phpEx?t=$topic_id");

$error['message'] = 'SUCCESS';
$error['return_topic'] = $topic_id;
//$url = "{$phpbb_root_path}viewtopic.php?t=$topic_id&f=$forum_id&sid=".$user->data['session_id']."";
$url = append_sid("{$phpbb_root_path}viewtopic.php?t=$topic_id&f=$forum_id");

meta_refresh(3, $url);
trigger_error(build_error_msg($error));

?>